from gturtle import *
import time, random
from math import pi, sin, cos

ALPHABLACK = makeColor(0, 0, 0, 0.125)
GRAVITY = -9
STEP = 0.05

points = []

def update_points():
    global points
    for i in indices(points):
        x, y, v_x, v_y, clr, r, l = points[i]
        x += v_x * STEP
        y += v_y * STEP
        v_y += GRAVITY * STEP
        if l > 0:
            l -= 1
            l_ = int(l ** 1.5)
            if l_ < r: r = l_
        points[i] = (x, y, v_x, v_y, clr, r, l)
    
def draw_points():
    for (x, y, v_x, v_y, clr, r, l) in points:
        if l != 0:
            setPenColor(clr)
            setPos(x, y)
            dot(r)

def update():
    clear(ALPHABLACK)
    update_points()
    draw_points()
    time.sleep(STEP * 0.5)
    repaint()

makeTurtle()
hideTurtle()
clear("black")
enableRepaint(False)

points.append((-200, -300, 20, 90, "red", 20, -1))
draw_points()
repeat:
    if points[0][3] < 0:
        break
    if getKeyCode() != 0:
        exit()
    update()

x, y, v_x, v_y, clr, r, l = points[0]
points = []
repeat 100:
    phi = random.randint(0, 360) * pi / 180
    sp = random.randint(10, 40)
    c = random.randint(0, 5) / 10
    vx = v_x + sp * sin(phi)
    vy = v_y + sp * cos(phi) + 10
    points.append((x, y, vx, vy, makeColor(1.0, 1.0, c), 10, int(3000 // sp)))

repeat:
    if getKeyCode() != 0:
        break
    update()
