
edges = [
('Paris', 'London'),
('London', 'Cambridge'),
('London', 'Oxford'),
('Paris', 'Marseille'),
('Marseille', 'Barcelona'),
('Marseille', 'Milano'),
('Milano', 'Rome'),
('Milano', 'Zurich'),
('Zurich', 'Paris'),
('Zurich', 'Munich'),
('Munich', 'Berlin'),
('Berlin', 'Amsterdam'),
('Amsterdam', 'London'),
('Amsterdam', 'Paris'),
('Munich', 'Vienna'),
('Milano', 'Vienna'),
('Vienna', 'Zurich'),
('Athens', 'Vienna'),
('Athens', 'Rome'),
]

vertices = {
  'Paris': [],
  'London': [],
  'Cambridge': [],
  'Oxford': [],
  'Berlin': [],
  'Amsterdam': [],
  'Marseille': [],
  'Milano': [],
  'Rome': [],
  'Zurich': [],
  'Munich': [],
  'Barcelona': [],  
  'Vienna': [],
  'Athens': [],
}

visiting = {
  'Paris': False,
  'London': False,
  'Cambridge': False,
  'Oxford': False,
  'Berlin': False,
  'Amsterdam': False,
  'Marseille': False,
  'Milano': False,
  'Rome': False,
  'Zurich': False,
  'Munich': False,
  'Barcelona': False,
  'Vienna': False,
  'Athens': False,
}

for (a, b) in edges:
    vertices[a].append(b)
    vertices[b].append(a)
    
def find_path(city, destination):
    if not visiting[city]:
        if destination in vertices[city]:
            return [city, destination]
        visiting[city] = True
        current_path = None
        for link in vertices[city]:
            path = find_path(link, destination)
            if path is not None:
                if current_path is None or len(current_path) > len(path):
                    current_path = [city] + path
        visiting[city] = False
        return current_path
    else:
        return None

print find_path('Barcelona', 'Athens')
