from gturtle import *
# Für Animationen brauchen wir "sleep"
from time import sleep
# Mit dem Sinus lassen wir das Schiff später leicht schaukeln
from math import sin, pi

makeTurtle()
hideTurtle()

def triangle(s):
    "Zeichnet ein gleichseitiges Dreieck in Elfenbein."
    setPenColor("ivory")
    fillToPoint()
    repeat 3:
        forward(s)
        left(120)
    fillOff()

def ship():
    "Zeichnet ein kleines Schiffchen."
    forward(200)
    left(150)
    triangle(200)
    setPenColor("brown")
    left(30)
    forward(200)
    fillToPoint()
    left(90)
    forward(100)
    right(120)
    forward(40)
    right(60)
    forward(200 - 40)
    right(60)
    forward(40)
    right(120)
    forward(100)
    fillOff()
    left(90)

def sea():
    "Zeichne das Meer unter dem Schiffchen."
    setPenColor("blue")
    penUp()
    forward(-50)
    right(90)
    forward(-300)
    penDown()
    setPenWidth(40)
    forward(600)
    setPenWidth(1)
    penUp()
    forward(-300)
    left(90)
    forward(50)
    penDown()
    
def goto(x):
    "Setzt die Turtle an die angegebene x-Koordinate."
    penUp()
    right(90)
    forward(x)
    left(90)
    penDown()

ship_pos = -200
angle = 0
# Um das Flackern zu vermeiden, soll Python nur noch dann zeichnen,
# wenn wir explizit "repaint()" schreiben. Wir schalten also das
# automatische Repaint hier aus.
enableRepaint(False)
repeat 400:
    # Das ganze Fenster löschen und mite "sky blue" füllen
    clean("sky blue")
    # Die Turtle in die Fenstermitte setzen
    home()
    # See zeichnen...
    sea()
    goto(ship_pos)
    # Indem wir die Turtle vor dem Zeichnen des Schiffs leicht
    # drehen, scheint das Schiff zu schaukeln.
    left(sin(angle * pi) * 2)
    ship()
    # Alle 100 Pixel spielen wir Meeresrauschen ab
    if ship_pos % 100 == 0:
        startTone("seashore")
    ship_pos += 1
    angle += 0.05
    repaint()
    # Mit "sleep(0.05)" haben wir etwa 20 Bilder pro Sekunde
    sleep(0.05)
